(define (RedBlue2CrossEye image EyeSpace)
(let* ( 
        ( lay1        (car (gimp-image-get-active-layer image)))
        ( w           (car (gimp-image-width image) ))
        ( h           (car (gimp-image-height image) ))
        ( scale       ( / w EyeSpace)) 
        ( h2          ( / h scale))
        ( pimage      (car(gimp-image-new (* 2 EyeSpace )  h2 0)))
        ( float       0) 
        ( laytemp     0) 
        ( laytemp2    0) 
        ( laycol      0) 
        ( play        0)  
      )
 
        (set! play      (car (gimp-layer-new pimage (* 2 EyeSpace )  h2 0 "play" 100 0)))
        (gimp-image-add-layer  pimage  play  -1)
        (set! laytemp  (car (gimp-layer-copy lay1 1)))
        (gimp-image-add-layer  image  laytemp  -1)
        (set! laycol  (car (gimp-layer-copy lay1 1)))
        (gimp-image-add-layer  image  laycol  -1)
        (gimp-context-set-foreground '(0 255 255))
        (gimp-drawable-fill laycol 0)
        (gimp-layer-set-mode laycol 3)
        (set! laytemp    (car (gimp-image-merge-down  image  laycol 0))    )
        (gimp-desaturate laytemp)
        (gimp-levels-stretch laytemp)
        
        (gimp-selection-all image)
        (gimp-edit-copy   laytemp )
        (set! float    (car (gimp-edit-paste play 1) ))
        (gimp-drawable-transform-scale-default  float 0 0 EyeSpace h2 1 0)
        (gimp-floating-sel-anchor float)
        
        (set! laytemp2  (car (gimp-layer-copy lay1 1)))
        (gimp-image-add-layer  image  laytemp2  -1)
        (set! laycol  (car (gimp-layer-copy lay1 1)))
        (gimp-image-add-layer  image  laycol  -1)
        (gimp-context-set-foreground '(255 0 0))
        (gimp-drawable-fill laycol 0)
        (gimp-layer-set-mode laycol 3)
        (set! laytemp2    (car (gimp-image-merge-down  image  laycol 0))    )
        (gimp-desaturate laytemp2)
        (gimp-levels-stretch laytemp2)
        
        (gimp-selection-all image)
        (gimp-edit-copy   laytemp2 )
        (set! float    (car (gimp-edit-paste play 1) ))
        (gimp-drawable-transform-scale-default  float EyeSpace 0 ( * 2 EyeSpace) h2 1 0)
        (gimp-floating-sel-anchor float)
        (gimp-display-new pimage)
        (gimp-image-remove-layer image lay1)
))


(script-fu-register "RedBlue2CrossEye"
                    "RedBlue2CrossEye"
                    "Converts Red Blue 3D to CrossEye Stereo 3D"
                    "Don Sauer www.idea2IC.com"
                    "GNU General Public License v3+"
                    "2012"
                    "RGB*"
                    SF-IMAGE      "Image" 0
		    SF-ADJUSTMENT "Eye_Spacing" '(300 200 600 50 1 1 0)
)

(script-fu-menu-register "RedBlue2CrossEye" "<Image>/Filters/Stereo 3D Stuff")      