; Cow-Blotches-Texture v2.5.0
; Copyright (c) 2005-2010 Frank Kessler <www.Kessnux.net>
;
; Tested with TheGIMP 2.6.7 under Mandriva Linux 2010 at 2010-03-20.
;
; This program based on the german Tutorial of Frank Kessler,
; the first version of the german Tutorial from 2004 based
; on techniques of Zach Beane (xach).
;
; This program is subjected to the Kessnux free usage license Version 1.0.
; If you have not received a copy of the KFNL, you could see it
; at http://www.kessnux.net/kfnl_10_en.php
;

(define (script-fu-cow-blotches-texture breite hoehe variation)

(let* ((bild (car (gimp-image-new breite hoehe 0)))
	(hg-layer (car (gimp-layer-new bild breite hoehe 0 "Hintergrund" 100 0)))
	(flecken-layer (car (gimp-layer-new bild (/ breite 2) (/ hoehe 2) 0 "Flecken" 100 0)))
	(nahtlos-layer (car (gimp-layer-new bild (/ breite 2) (/ hoehe 2) 0 "nahtlos" 100 0)))
	(verbundener-layer (car (gimp-layer-new bild (/ breite 2) (/ hoehe 2) 0 "verbunden" 100 0)))
	(ff-alt (car (gimp-palette-get-foreground)))
	(hf-alt (car (gimp-palette-get-foreground))))
	
	(gimp-image-undo-disable bild)
	
	(gimp-image-add-layer bild hg-layer 1)
	(gimp-image-add-layer bild flecken-layer -1)
	
	;Layer vorbereiten
	(gimp-palette-set-foreground '(255 255 255))
	(gimp-edit-clear hg-layer)
	(gimp-edit-fill hg-layer 0)
	(gimp-edit-clear flecken-layer)
	(gimp-edit-fill flecken-layer 0)
	
	;Flecken erzeugen
	(plug-in-rgb-noise TRUE bild flecken-layer FALSE FALSE 0.90 0.90 0.90 0.90)
	(plug-in-spread TRUE bild flecken-layer 10 10)
	(plug-in-spread TRUE bild flecken-layer 10 10)
	(plug-in-spread TRUE bild flecken-layer 10 10)
	(plug-in-gauss TRUE bild flecken-layer 10 10 1)
	(plug-in-c-astretch TRUE bild flecken-layer)
	(gimp-threshold flecken-layer (+ 150 (* -1 (- 150 variation))) 255)
	(plug-in-gauss TRUE bild flecken-layer 1 1 1)
	
	;nahtlos machen
	(set! nahtlos-layer (car(gimp-layer-copy flecken-layer 1)))
	(gimp-image-add-layer bild nahtlos-layer -1)
	(gimp-flip nahtlos-layer 0)
	(gimp-layer-set-offsets nahtlos-layer (/ breite 2) 0)
	(set! verbundener-layer (car(gimp-image-merge-down bild nahtlos-layer 0)))
	(set! nahtlos-layer (car(gimp-layer-copy verbundener-layer 1)))
	(gimp-image-add-layer bild nahtlos-layer -1)
	(gimp-flip nahtlos-layer 1)
	(gimp-layer-set-offsets nahtlos-layer 0 (/ hoehe 2))
	(gimp-image-merge-down bild nahtlos-layer 0)
	
	;alten Zustand wiederherstellen
	(gimp-palette-set-foreground ff-alt)
	(gimp-palette-set-background hf-alt)
	 
	(gimp-image-undo-enable bild)
	(gimp-display-new bild)))
	
(script-fu-register "script-fu-cow-blotches-texture"
		    "<Image>/Filters/Render/Pattern/Cow-Blotches-Texture"
		    "generates a texture with cow-blotches"
		    "Frank Kessler"
		    "Frank Kessler"
		    "2010"
		    ""
		    SF-ADJUSTMENT "Image width"               '(300 1 1024 1 10 0 1)
		    SF-ADJUSTMENT "Image height"              '(300 1 1024 1 10 0 1)
		    SF-ADJUSTMENT "Intensity"                 '(140 1 255 1 5 0 0))
		    